
@model FAA_UI.ViewModels.MaintenanceViewModel
<div class="row" style="margin:0px;padding:0px;">
    <!-- Tabs navs -->
    <ul class="nav nav-tabs" id="testTab" role="tablist">
        <li class="nav-item" role="presentation">
            <a href="#tab_1" class="nav-link active" role="tab" data-bs-toggle="tab" aria-controls="tab_1" id="tab_system" aria-selected="true">System Settings</a>
        </li>
        <li class="nav-item" role="presentation">
            <a href="#tab_2" class="nav-link" role="tab" data-bs-toggle="tab" aria-controls="tab_2" id="tab_instrument" aria-selected="false">Instrument Settings</a>
        </li>
        <li class="nav-item" role="presentation">
            <a href="#tab_3" class="nav-link" role="tab" data-bs-toggle="tab" aria-controls="tab_3" id="tab_check" aria-selected="false">Instrument Check</a>
        </li>
        <li class="nav-item" role="presentation">
            <a href="#tab_4" class="nav-link" role="tab" data-bs-toggle="tab" aria-controls="tab_4" id="tab_temp" aria-selected="false">Temperature and Pressure Check</a>
        </li>
        <li class="nav-item" role="presentation">
            <a href="#tab_5" class="nav-link" role="tab" data-bs-toggle="tab" aria-controls="tab_5" id="tab_photo" aria-selected="false">Photometer Maintenance</a>
        </li>
        <li class="nav-item" role="presentation">
            <a href="#tab_6" class="nav-link" role="tab" data-bs-toggle="tab" aria-controls="tab_6" id="tab_cuvette" aria-selected="false">Cuvette Maintenance</a>
        </li>
    </ul>
    <div class="tab-content" id="testContent">
        <div class="tab-pane fade show active" id="tab_1" role="tabpanel" aria-labelledby="tab_1">
            @await Html.PartialAsync("_SystemSettings",Model.systemSetting)
        </div> 
        <div class="tab-pane fade" id="tab_2" role="tabpanel" aria-labelledby="tab_2">
            @await Html.PartialAsync("_InstrumentSettings",Model.instrumentSetting)
        </div>
        <div class="tab-pane fade" id="tab_3" role="tabpanel" aria-labelledby="tab_3">
            @await Html.PartialAsync("_InstrumentCheck")
        </div>
        <div class="tab-pane fade" id="tab_4" role="tabpanel" aria-labelledby="tab_4">
            @await Html.PartialAsync("_TemperaturePressureCheck")
        </div>
        <div class="tab-pane fade" id="tab_5" role="tabpanel" aria-labelledby="tab_5">
            @await Html.PartialAsync("_PhotometerCheck")
        </div>
        <div class="tab-pane fade" id="tab_6" role="tabpanel" aria-labelledby="tab_6">
            @await Html.PartialAsync("_CuvetteMaintenance")
        </div>
    </div>
</div>

@section Scripts
{
    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
<script type="text/javascript">
    var selectedId="";
    var selectedStep="";
    var IsAD_ValueDetection=false;
    jQuery("#btnWashingAllCuvettes").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/WashAllCuvette",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function ()
            {
               // alert(data.msg);
            },
            error: function ()
            {
               // alert("Error occured!!")
            }
        });
    });

    jQuery("#btnInit").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/Init",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function ()
            {
                //alert(data.msg);
            },
            error: function ()
            {
               // alert("Error occured!!");
            }
        });
    });
    jQuery("#btnSaveInstrument").click(function ()
    {
        jQuery.ajax({
            type: "GET",
            url: "/Maintenance/SaveInstrumentSettings",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            data: $('#formInstrumentSettings').serializeArray(),
            success: function (data)
            {
                alert("Instrument Settings Updated Successfully");
            },
            error: function ()
            {
                alert("Error occured!!");
            }
        });
    });

    jQuery("#btnTest").click(function ()
    {
        //alert(selectedId);
        jQuery.ajax({
            type: "GET",
            url: "/Maintenance/CheckSetting",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            data:{selectedID: selectedId.toString(),Steps: selectedStep.toString()},
            success: function (data)
            {
               // alert(data);
            },
            error: function ()
            {
                alert("Error occured!!");
            }
        });
    });

    jQuery("#btnAllArmUp").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/AllArmUp",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function ()
            {
                //alert(data.msg);
            },
            error: function ()
            {
               // alert("Error occured!!");
            }
        });
    });

    $("#btnSaveSystemSetting").click(function()
    {
        var myForm = document.getElementById('formSystemSettings');
        var formData = new FormData(myForm);
        //var data=formData;
        
        $.ajax('/Maintenance/SaveSystemSettings', {
            type: 'POST',
            data: formData,
            processData: false,
            contentType: false,
            success: function () {
              location.reload();
            },
            error: function (jqXhr, textStatus, errorMessage) {
                alert("Unknown Error!!:"+errorMessage);
            }
        });
    });

    function onfocusIn(txt)
    {
        selectedId=txt.id;
        const myElement = document.getElementById(selectedId);
        selectedStep=myElement.value;
        myElement.style.backgroundColor = "#90111A";
        myElement.style.color = "white";
    }

    function onfocusOut(txt)
    {
        selectedId=txt.id;  
        const myElement = document.getElementById(selectedId);
        selectedStep=myElement.value;
        myElement.style.backgroundColor = "white";
        myElement.style.color = "black";
    }


    jQuery("#btnProbeValveCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/ProbeValveCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnTroughValveCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/TroughValveCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnCruValveCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/CruValveCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnPumpCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/PumpCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnPumpbackCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/PumpbackCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });


    jQuery("#btnStirrerCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/StirrerCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });


    jQuery("#btnSyringeOffsetCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/SyringeOffsetCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (result){
                $("#txtSyringeOffset").val(result);
            },
            error: function (){}
        });
    });

    jQuery("#btnArmMoveHorizontal").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/ArmMoveHorizontal",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnArmUp").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/ArmUp",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnArmDown").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/ArmDown",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnArmInit").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/ArmInit",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });


    jQuery("#btnStrMoveHorizontal").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/StrMoveHorizontal",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnStrUp").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/StrUp",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnStrDown").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/StrDown",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnStrInit").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/StrInit",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnWasteSensorCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/WasteSensorCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnDiSensorCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/DiSensorCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnDetergentCheck").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/DetergentCheck",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnBarcodeCheck").click(function ()
    {
         jQuery.ajax({
            type: "POST",
            url: "/Maintenance/BarcodeCheck",
            /*dataType: "json",
            contentType: 'application/json; charset=utf-8',*/
            processData: false,
            contentType: false,
            success: function (result){
                $("#txtBarcodeString").val(result);
            },
            error: function (){}
        });
    });

    jQuery("#btnLampOn").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/LampOn",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });

    jQuery("#btnLampOff").click(function ()
    {
        jQuery.ajax({
            type: "POST",
            url: "/Maintenance/LampOff",
            dataType: "json",
            contentType: 'application/json; charset=utf-8',
            success: function (){},
            error: function (){}
        });
    });


    jQuery("#tab_system").click(function ()
    {
        IsAD_ValueDetection=false;
    });

    jQuery("#tab_instrument").click(function ()
    {
        IsAD_ValueDetection=false;
    });

    jQuery("#tab_check").click(function ()
    {
        IsAD_ValueDetection=false;
    });

    jQuery("#tab_temp").click(function ()
    {
        IsAD_ValueDetection=false;
    });

    jQuery("#tab_cuvette").click(function ()
    {
        IsAD_ValueDetection=false;
    });
    

    $("#btnTest").mousedown(function(e) {
        e.preventDefault(); 
    });
    $("#btnArmUp").mousedown(function(e) {
        e.preventDefault();
    }); 
    $("#btnInit").mousedown(function(e) {
        e.preventDefault();
    }); 
    $("#btnSaveInstrument").mousedown(function(e) {
        e.preventDefault();
    }); 
    $("#btnCancel").mousedown(function(e) {
        e.preventDefault();
    });

    jQuery("#btnZero").click(function ()
    {
        for (let i = 0; i < result.length; i++) {
            zeroReading[i]=result[i];
        }
    }); 

    google.charts.load('current', { 'packages': ['corechart'] });
    jQuery("#tab_photo").click(function ()
    {
        IsAD_ValueDetection=true;
        google.charts.setOnLoadCallback(callback);
        //ReadADC_Data();
    });

    

        function callback() {
            var option = {
                title: "Real-Time Chart",
                width: document.getElementsByClassName('panel panel-default').width,
                height: document.getElementsByClassName('panel panel-default').height,
                legend: { position: 'none' },
                vAxis: { viewWindow: { min: -1, max: 65000 }, baselineColor: 'transparent'  },
                chartArea: { height: '80%', width: '90%', left: 100, 
                             backgroundColor: { stroke: "gray", strokeWidth: 1 } },
                pointSize: 10
            };
            var chart = new google.visualization.LineChart(document.getElementById('chartRealTimeFilterData'));
            var data = new google.visualization.DataTable();
            data.addColumn('number', 'Time');
            data.addColumn('number', 'Count');

            var zeroReading=[0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0];

            var cntReading=0;
            var selectedVal = 1;
            var preSelectedVal=1;

            ReadADC_Data();
            //setInterval(ReadADC_Data, 1000);

            function ReadADC_Data()
            {
            jQuery.ajax({
                    type: "POST",
                    url: "/Maintenance/StartMonitoring",
                    dataType: "json",
                    contentType: 'application/json; charset=utf-8',
                    processData: false,
                    contentType: false,
                    success: function (result){
                        //$("#txtBarcodeString").val(result);
                        if(result)
                        {
                            for (let i = 0; i < result.length; i++) {
                               
                                
                            }

                            
                            var selected = $("input[type='radio'][name='btnFilter']:checked");
                            if (selected.length > 0) {
                                selectedVal = selected.val();
                            }
                            if(selectedVal!=preSelectedVal)
                            {
                                data=new google.visualization.DataTable();
                                data.addColumn('number', 'Time');
                                data.addColumn('number', 'Count');
                                cntReading=0;
                            }
                              
                            for (let i = 0; i < result.length; i++) {
                                if(cntReading==0)
                                {
                                    zeroReading[i]=result[i];
                                }
                                var valOd = -Math.log(result[i]/zeroReading[i]);

                                $("#txtFilter"+(i+1)+"Count").val(result[i]);
                                $("#txtFilter"+(i+1)+"Od").val(valOd);
                            }

                            var val = -Math.log(result[selectedVal-1]/zeroReading[selectedVal-1]);                  
                            data.addRow([cntReading++, val]);
                            chart.draw(data, option);
                            preSelectedVal=selectedVal;
                        }
                        console.log(result);
                        option = {
                            title: "Real-Time Chart",
                            width: document.getElementsByClassName('container').width,
                            height: document.getElementsByClassName('container').height,
                            legend: { position: 'none' },
                           /* vAxis: { viewWindow: { min:data.getColumnRange(1).min-50, max: data.getColumnRange(1).max+50 }, baselineColor: 'transparent'  },*/
                           vAxis: { viewWindow: { min:0, max: data.getColumnRange(1).max+0.01 }, baselineColor: 'transparent'  },
                            chartArea: { height: '80%', width: '90%', left: 100, 
                                        backgroundColor: { stroke: "gray", strokeWidth: 1 } },
                            pointSize: 10
                        };
                        if(IsAD_ValueDetection==true)
                        {
                            setTimeout(ReadADC_Data, 1000);
                        }
                    // ReadADC_Data();
                    },
                    error: function (){}
                });
            }
        }

</script>
}